## GFileEnumerator

GFileEnumerator — Enumerated Files Routines

## Functions

gboolean | g_file_enumerator_iterate ()
GFileInfo * | g_file_enumerator_next_file ()
gboolean | g_file_enumerator_close ()
void | g_file_enumerator_next_files_async ()
GList * | g_file_enumerator_next_files_finish ()
void | g_file_enumerator_close_async ()
gboolean | g_file_enumerator_close_finish ()
gboolean | g_file_enumerator_is_closed ()
gboolean | g_file_enumerator_has_pending ()
void | g_file_enumerator_set_pending ()
GFile * | g_file_enumerator_get_container ()
GFile * | g_file_enumerator_get_child ()

## Properties

GFile * | container | Write / Construct Only

## Types and Values

| GFileEnumerator

## Object Hierarchy

        GObject
        ╰── GFileEnumerator

## Includes

    #include <gio/gio.h>

## Description

GFileEnumerator allows you to operate on a set of GFiles, returning a GFileInfo structure for each file enumerated (e.g. `g_file_enumerate_children()` will return a GFileEnumerator for each of the children within a directory).

To get the next file's information from a GFileEnumerator, use `g_file_enumerator_next_file()` or its asynchronous version, `g_file_enumerator_next_files_async()`. Note that the asynchronous version will return a list of GFileInfos, whereas the synchronous will only return the next file in the enumerator.

The ordering of returned files is unspecified for non-Unix platforms; for more information, see `g_dir_read_name()`. On Unix, when operating on local files, returned files will be sorted by inode number. Effectively you can assume that the ordering of returned files will be stable between successive calls (and applications) assuming the directory is unchanged.

If your application needs a specific ordering, such as by name or modification time, you will have to implement that in your application code.

To close a GFileEnumerator, use `g_file_enumerator_close()`, or its asynchronous version, `g_file_enumerator_close_async()`. Once a GFileEnumerator is closed, no further actions may be performed on it, and it should be freed with `g_object_unref()`.

## Functions

### g_file_enumerator_iterate ()

    gboolean
    g_file_enumerator_iterate (GFileEnumerator *direnum,
                               GFileInfo **out_info,
                               GFile **out_child,
                               GCancellable *cancellable,
                               GError **error);

This is a version of `g_file_enumerator_next_file()` that's easier to use correctly from C programs. With `g_file_enumerator_next_file()`, the gboolean return value signifies "end of iteration or error", which requires allocation of a temporary GError.

In contrast, with this function, a `FALSE` return from `g_file_enumerator_iterate()` *always* means "error". End of iteration is signaled by `out_info` or `out_child` being `NULL`.

Another crucial difference is that the references for `out_info` and `out_child` are owned by `direnum` (they are cached as hidden properties). You must not unref them in your own code. This makes memory management significantly easier for C code in combination with loops.

Finally, this function optionally allows retrieving a GFile as well.

You must specify at least one of `out_info` or `out_child` .

The code pattern for correctly using `g_file_enumerator_iterate()` from C is:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13

    direnum = g_file_enumerate_children (file, ...);
    while (TRUE)
      {
        GFileInfo *info;
        if (!g_file_enumerator_iterate (direnum, &info, NULL, cancellable, error))
          goto out;
        if (!info)
          break;
        ... do stuff with "info"; do not unref it! ...
      }

    out:
      g_object_unref (direnum); // Note: frees the last @info

#### Parameters

direnum | an open GFileEnumerator |
out_info | Output location for the next GFileInfo, or `NULL`. | [out][transfer none][optional]
out_child | Output location for the next GFile, or `NULL`. | [out][transfer none][optional]
cancellable | a GCancellable |
error | a GError |

Since: 2.44

### g_file_enumerator_next_file ()

    GFileInfo *
    g_file_enumerator_next_file (GFileEnumerator *enumerator,
                                 GCancellable *cancellable,
                                 GError **error);

Returns information for the next file in the enumerated object. Will block until the information is available. The GFileInfo returned from this function will contain attributes that match the attribute string that was passed when the GFileEnumerator was created.

See the documentation of GFileEnumerator for information about the order of returned files.

On error, returns `NULL` and sets `error` to the error. If the enumerator is at the end, `NULL` will be returned and `error` will be unset.

#### Parameters

enumerator | a GFileEnumerator. |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |

#### Returns

A GFileInfo or `NULL` on error or end of enumerator. Free the returned object with `g_object_unref()` when no longer needed.

[nullable][transfer full]

### g_file_enumerator_close ()

    gboolean
    g_file_enumerator_close (GFileEnumerator *enumerator,
                             GCancellable *cancellable,
                             GError **error);

Releases all resources used by this enumerator, making the enumerator return `G_IO_ERROR_CLOSED` on all calls.

This will be automatically called when the last reference is dropped, but you might want to call this function to make sure resources are released as early as possible.

#### Parameters

enumerator | a GFileEnumerator. |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |

#### Returns

TRUE on success or FALSE on error.

### g_file_enumerator_next_files_async ()

    void
    g_file_enumerator_next_files_async (GFileEnumerator *enumerator,
                                        int num_files,
                                        int io_priority,
                                        GCancellable *cancellable,
                                        GAsyncReadyCallback callback,
                                        gpointer user_data);

Request information for a number of files from the enumerator asynchronously. When all i/o for the operation is finished the `callback` will be called with the requested information.

See the documentation of GFileEnumerator for information about the order of returned files.

The callback can be called with less than `num_files` files in case of error or at the end of the enumerator. In case of a partial error the callback will be called with any succeeding items and no error, and on the next request the error will be reported. If a request is cancelled the callback will be called with `G_IO_ERROR_CANCELLED`.

During an async request no other sync and async calls are allowed, and will result in `G_IO_ERROR_PENDING` errors.

Any outstanding i/o request with higher priority (lower numerical value) will be executed before an outstanding request with lower priority. Default priority is `G_PRIORITY_DEFAULT`.

#### Parameters

enumerator | a GFileEnumerator. |
num_files | the number of file info objects to request |
io_priority | the I/O priority of the request |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | a GAsyncReadyCallback to call when the request is satisfied. | [scope async]
user_data | the data to pass to callback function. | [closure]

### g_file_enumerator_next_files_finish ()

    GList *
    g_file_enumerator_next_files_finish (GFileEnumerator *enumerator,
                                         GAsyncResult *result,
                                         GError **error);

Finishes the asynchronous operation started with `g_file_enumerator_next_files_async()`.

#### Parameters

enumerator | a GFileEnumerator. |
result | a GAsyncResult. |
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

a GList of GFileInfos. You must free the list with `g_list_free()` and unref the infos with `g_object_unref()` when you're done with them.

[transfer full][element-type Gio.FileInfo]

### g_file_enumerator_close_async ()

    void
    g_file_enumerator_close_async (GFileEnumerator *enumerator,
                                   int io_priority,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

Asynchronously closes the file enumerator.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned in `g_file_enumerator_close_finish()`.

#### Parameters

enumerator | a GFileEnumerator. |
io_priority | the I/O priority of the request |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | a GAsyncReadyCallback to call when the request is satisfied. | [scope async]
user_data | the data to pass to callback function. | [closure]

### g_file_enumerator_close_finish ()

    gboolean
    g_file_enumerator_close_finish (GFileEnumerator *enumerator,
                                    GAsyncResult *result,
                                    GError **error);

Finishes closing a file enumerator, started from `g_file_enumerator_close_async()`.

If the file enumerator was already closed when `g_file_enumerator_close_async()` was called, then this function will report `G_IO_ERROR_CLOSED` in `error` , and return `FALSE`. If the file enumerator had pending operation when the close operation was started, then this function will report `G_IO_ERROR_PENDING`, and return `FALSE`. If `cancellable` was not `NULL`, then the operation may have been cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be set, and `FALSE` will be returned.

#### Parameters

enumerator | a GFileEnumerator. |
result | a GAsyncResult. |
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

`TRUE` if the close operation has finished successfully.

### g_file_enumerator_is_closed ()

    gboolean
    g_file_enumerator_is_closed (GFileEnumerator *enumerator);

Checks if the file enumerator has been closed.

#### Parameters

enumerator | a GFileEnumerator. |

#### Returns

`TRUE` if the `enumerator` is closed.

### g_file_enumerator_has_pending ()

    gboolean
    g_file_enumerator_has_pending (GFileEnumerator *enumerator);

Checks if the file enumerator has pending operations.

#### Parameters

enumerator | a GFileEnumerator. |

#### Returns

`TRUE` if the `enumerator` has pending operations.

### g_file_enumerator_set_pending ()

    void
    g_file_enumerator_set_pending (GFileEnumerator *enumerator,
                                   gboolean pending);

Sets the file enumerator as having pending operations.

#### Parameters

enumerator | a GFileEnumerator. |
pending | a boolean value. |

### g_file_enumerator_get_container ()

    GFile *
    g_file_enumerator_get_container (GFileEnumerator *enumerator);

Get the GFile container which is being enumerated.

#### Parameters

enumerator | a GFileEnumerator |

#### Returns

the GFile which is being enumerated.

[transfer none]

Since: 2.18

### g_file_enumerator_get_child ()

    GFile *
    g_file_enumerator_get_child (GFileEnumerator *enumerator,
                                 GFileInfo *info);

Return a new GFile which refers to the file named by `info` in the source directory of `enumerator` . This function is primarily intended to be used inside loops with `g_file_enumerator_next_file()`.

This is a convenience method that's equivalent to:

    1
    2
    3

    gchar *name = g_file_info_get_name (info);
    GFile *child = g_file_get_child (g_file_enumerator_get_container (enumr),
                                     name);

#### Parameters

enumerator | a GFileEnumerator |
info | a GFileInfo gotten from `g_file_enumerator_next_file()` or the async equivalents. |

#### Returns

a GFile for the GFileInfo passed it.

[transfer full]

Since: 2.36

## Types and Values

### GFileEnumerator

    typedef struct _GFileEnumerator GFileEnumerator;

A per matched file iterator.

## Property Details

### The `“container”` property

      “container”                GFile *

The container that is being enumerated.

Flags: Write / Construct Only